%define ver 1.3.0

Name: proftpd
Version: %{ver}rc1
Release: alt2

Summary: ProFTPd -- Professional FTP Server
License: GPL
Group: System/Servers
Url: http://www.%name.org/

Source: ftp://ftp.%name.org/pub/%name/%name-%version.tar.bz2
Source1: %name.logrotate
Source2: %name.xinetd
Source3: %name.init
Source4: %name.pamd

Patch0: %name-conf.patch
Patch1: %name-man.patch
Patch3: %name-1.3.0rc1-ldap.patch
Patch4: %name-ldap-config.patch
Patch5: %name-1.2.10-iconv.patch
Patch6: %name-1.3.0rc1-mod_sql_mysql.patch
Patch7: %name-1.3.0rc1-mod_sql_postgres.patch
Patch8: %name-1.3.0rc1-hidenoaccess-in-chroot.patch

Provides: ftpserver
Conflicts: wu-ftpd, ncftpd, beroftpd
PreReq: anonftp
AutoReq: yes, noshell

# Automatically added by buildreq on Mon May 30 2005
BuildRequires: gcc-c++ libMySQL-devel libacl-devel libldap-devel libncurses-devel libpam-devel libpq4-devel libssl-devel libstdc++-devel libtinfo-devel libwrap-devel postgresql8.0-devel zlib-devel

%description
ProFTPd is an enhanced FTP server with a focus toward simplicity, security,
and ease of configuration.  It features a very Apache-like configuration
syntax, and a highly customizable server infrastructure, including support for
multiple 'virtual' FTP servers, anonymous FTP, and permission-based directory
visibility.

This package will setup ProFTPd for both inetd and standalone operations.

%package -n %name-mod_ctrls_admin
Summary: Module implementing admin control handlers
Group: System/Servers
Requires: %name = %version-%release

%package -n %name-mod_ifsession
Summary: Module supporting conditional per-user/group/class configuration contexts
Group: System/Servers
Requires: %name = %version-%release

%package -n %name-mod_ldap
Summary: LDAP password lookup module for ProFTPD
Group: System/Servers
Requires: %name = %version-%release

%package -n %name-mod_quotatab
Summary: Module for managing FTP byte/file quotas via centralized tables
Group: System/Servers
Requires: %name = %version-%release

%package -n %name-mod_quotatab_file
Summary: Sub-module for managing quota data via file-based tables
Group: System/Servers
Requires: %name-mod_quotatab = %version-%release

%package -n %name-mod_quotatab_ldap
Summary: Sub-module for obtaining quota information from an LDAP directory
Group: System/Servers
Requires: %name-mod_quotatab = %version-%release

%package -n %name-mod_quotatab_sql
Summary: Sub-module for managing quota data via SQL-based tables
Group: System/Servers
Requires: %name-mod_quotatab = %version-%release

%package -n %name-mod_radius
Summary: Module for RADIUS authentication and accounting
Group: System/Servers
Requires: %name = %version-%release

%package -n %name-mod_ratio
Summary: Support upload/download ratios
Group: System/Servers
Requires: %name = %version-%release

%package -n %name-mod_rewrite
Summary: Module for rewriting FTP commands
Group: System/Servers
Requires: %name = %version-%release

%package -n %name-mod_site_misc
Summary: Module implementing miscellaneous SITE commands
Group: System/Servers
Requires: %name = %version-%release

%package -n %name-mod_sql
Summary: SQL frontend
Group: System/Servers
Requires: %name = %version-%release

%package -n %name-mod_sql_mysql
Summary: Support for connecting to MySQL databases
Group: System/Servers
Requires: %name-mod_sql = %version-%release

%package -n %name-mod_sql_postgres
Summary: Support for connecting to Postgres databases
Group: System/Servers
Requires: %name-mod_sql = %version-%release

%package -n %name-mod_tls
Summary: An RFC2228 SSL/TLS module for ProFTPD
Group: System/Servers
Requires: %name = %version-%release

%package -n %name-mod_facl
Summary: POSIX ACL checking code (aka POSIX.1e hell)
Group: System/Servers
Requires: %name = %version-%release

%description -n %name-mod_ctrls_admin
This module implements administrative control actions for the ftpdctl program.

%description -n %name-mod_ifsession
Module supporting conditional per-user/group/class configuration contexts

%description -n %name-mod_ldap
LDAP password lookup module for ProFTPD

%description -n %name-mod_quotatab
Module for managing FTP byte/file quotas via centralized tables

%description -n %name-mod_quotatab_file
Sub-module for managing quota data via file-based tables

%description -n %name-mod_quotatab_ldap
Sub-module for obtaining quota information from an LDAP directory

%description -n %name-mod_quotatab_sql
Sub-module for managing quota data via SQL-based tables

%description -n %name-mod_radius
Module for RADIUS authentication and accounting

%description -n %name-mod_ratio
Support upload/download ratios

%description -n %name-mod_rewrite
Module for rewriting FTP commands

%description -n %name-mod_site_misc
Module implementing miscellaneous SITE commands

%description -n %name-mod_sql
SQL frontend

%description -n %name-mod_sql_mysql
Support for connecting to MySQL databases

%description -n %name-mod_sql_postgres
Support for connecting to Postgres databases

%description -n %name-mod_tls
An RFC2228 SSL/TLS module for ProFTPD

%description -n %name-mod_facl
POSIX ACL checking code (aka POSIX.1e hell)

%prep
%setup -q -n %name-%version
%patch0 -p1
%patch1 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1

%build
#%_target_platform --prefix=%prefix \
%configure --sysconfdir=%_sysconfdir \
	    --localstatedir=/var/run \
	    --enable-auth-pam \
	    --enable-ctrls \
	    --enable-largefile \
	    --libexecdir=%_libexecdir/%name \
	    --enable-autoshadow --enable-sendfile --enable-dso \
	    --with-modules=mod_auth_pam:mod_readme:mod_wrap:mod_df:mod_codeconv \
	    --with-shared=mod_ctrls_admin:mod_ifsession:mod_ldap:mod_quotatab:mod_quotatab_file:mod_quotatab_ldap:mod_quotatab_sql:mod_radius:mod_ratio:mod_rewrite:mod_site_misc:mod_sql:mod_sql_mysql:mod_sql_postgres:mod_tls:mod_facl
%make

%install
myname=`id -un`
mygroup=`id -gn`

%__mkdir_p %buildroot%_libexecdir/%name
%makeinstall localstatedir=%buildroot/var/run rundir=%buildroot/var/run/%name LIBEXECDIR=%buildroot%_libexecdir/%name \
	INSTALL_USER=$myname INSTALL_GROUP=$mygroup

%__install -pD -m640 %SOURCE4 %buildroot%_sysconfdir/pam.d/ftp
%__install -p -m644 -D sample-configurations/basic.conf %buildroot%_sysconfdir/%name.conf
%__install -p -m644 -D %SOURCE1 %buildroot%_sysconfdir/logrotate.d/%name
%__install -p -m644 -D %SOURCE2 %buildroot%_sysconfdir/xinetd.d/%name
%__install -p -m755 -D %SOURCE3 %buildroot%_initdir/%name
%__install -m755 contrib/xferstats.holger-preiss %buildroot%_sbindir

%__chmod 711 %buildroot%_sbindir/%name

%__ln_s -f %name %buildroot%_sbindir/in.%name
%__ln_s -f %name %buildroot%_sbindir/in.ftpd

echo >>%buildroot%_sysconfdir/ftpusers <<EOF
root
bin
daemon
adm
lp
sync
shutdown
halt
mail
news
uucp
operator
games
nobody
EOF

%__mkdir_p %buildroot/var/log/%name
%__rm -f %buildroot%_libexecdir/%name/*.a
%__rm -f %buildroot%_libexecdir/%name/*.la

%post
%post_service %name

%preun
%preun_service %name

%files
%doc README* ChangeLog INSTALL NEWS CREDITS doc/* contrib/README.* contrib/INSTALL.*
%doc sample-configurations/* contrib/ftpasswd contrib/ftpquota
%attr(600,root,root) %config(noreplace) %_sysconfdir/%name.conf
%config(noreplace) %_sysconfdir/ftpusers
%config(noreplace) %_sysconfdir/pam.d/ftp
%config(noreplace) %_initdir/%name
%config(noreplace) %_sysconfdir/xinetd.d/%name
%config(noreplace) %_sysconfdir/logrotate.d/%name
%_sbindir/*
%_bindir/*
%_man1dir/ftpwho.*
%_man1dir/ftpcount.*
%_man1dir/ftptop.*
%_man5dir/xferlog.*
%_man8dir/%name.*
%_man8dir/ftpshut.*
%_man8dir/ftpdctl.*
%dir /var/run/%name
%dir /var/log/%name
%dir %_libexecdir/%name

%files -n %name-mod_ctrls_admin
%_libexecdir/%name/mod_ctrls_admin.so

%files -n %name-mod_ifsession
%_libexecdir/%name/mod_ifsession.so

%files -n %name-mod_ldap
%_libexecdir/%name/mod_ldap.so

%files -n %name-mod_quotatab
%_libexecdir/%name/mod_quotatab.so

%files -n %name-mod_quotatab_file
%_libexecdir/%name/mod_quotatab_file.so

%files -n %name-mod_quotatab_ldap
%_libexecdir/%name/mod_quotatab_ldap.so

%files -n %name-mod_quotatab_sql
%_libexecdir/%name/mod_quotatab_sql.so

%files -n %name-mod_radius
%_libexecdir/%name/mod_radius.so

%files -n %name-mod_ratio
%_libexecdir/%name/mod_ratio.so

%files -n %name-mod_rewrite
%_libexecdir/%name/mod_rewrite.so

%files -n %name-mod_site_misc
%_libexecdir/%name/mod_site_misc.so

%files -n %name-mod_sql
%_libexecdir/%name/mod_sql.so

%files -n %name-mod_sql_mysql
%_libexecdir/%name/mod_sql_mysql.so

%files -n %name-mod_sql_postgres
%_libexecdir/%name/mod_sql_postgres.so

%files -n %name-mod_tls
%_libexecdir/%name/mod_tls.so

%files -n %name-mod_facl
%_libexecdir/%name/mod_facl.so
	
%changelog
* Mon May 30 2005 Konstantin Timoshenko <kt@altlinux.ru> 1.3.0rc1-alt2
- - rebuild with libpq4-devel

* Mon Apr 18 2005 Konstantin Timoshenko <kt@altlinux.ru> 1.3.0rc1-alt1
- 1.3.10rc1
- add local <-> remote charset conversion patch
- Multi package creation.

* Thu May 06 2004 Konstantin Timoshenko <kt@altlinux.ru> 1.2.10rc1-alt2
- rebuild with glibc-2.3

* Fri Apr 30 2004 Konstantin Timoshenko <kt@altlinux.ru> 1.2.10rc1-alt1
- 1.2.10rc1

* Fri Oct 31 2003 Konstantin Timoshenko <kt@altlinux.ru> 1.2.9release-alt1
- 1.2.9 release

* Mon Oct 21 2003 Konstantin Timoshenko <kt@altlinux.ru> 1.2.9rc3-alt1
- 1.2.9rc3

* Wed Sep 24 2003 Konstantin Timoshenko <kt@altlinux.ru> 1.2.9rc2-alt3
- security fix

* Fri Sep 19 2003 Konstantin Timoshenko <kt@altlinux.ru> 1.2.9rc2-alt2
- fix wrong prereq.

* Mon Sep 15 2003 Konstantin Timoshenko <kt@altlinux.ru> 1.2.9rc2-alt1
- 1.2.9rc2

* Tue Jul 29 2003 Konstantin Timoshenko <kt@altlinux.ru> 1.2.9rc1-alt1
- 1.2.9rc1
- Rewritten start/stop script to new rc scheme.

* Wed Mar 12 2003 Konstantin Timoshenko <kt@altlinux.ru> 1.2.8release-alt1
- 1.2.8 release

* Fri Feb 07 2003 Konstantin Timoshenko <kt@altlinux.ru> 1.2.8-alt2.rc1
- fix logrotate config.

* Mon Jan 20 2003 Konstantin Timoshenko <kt@altlinux.ru> 1.2.8-alt1.rc1
- 1.2.8rc1

* Mon Nov 11 2002 Konstantin Timoshenko <kt@altlinux.ru> 1.2.7-alt2.rc2
- rebuild with libwrap

* Thu Oct 24 2002 Konstantin Timoshenko <kt@altlinux.ru> 1.2.7-alt1.rc2
- 1.2.7rc2

* Tue Oct 22 2002 Konstantin Timoshenko <kt@altlinux.ru> 1.2.7-alt1.rc1
- 1.2.7rc1

* Mon Sep 16 2002 Konstantin Timoshenko <kt@altlinux.ru> 1.2.6release-alt1
- 1.2.6 release

* Mon Aug 19 2002 Konstantin Timoshenko <kt@altlinux.ru> 1.2.6rc2-alt1
- 1.2.6rc2

* Fri May 31 2002 Konstantin Timoshenko <kt@altlinux.ru> 1.2.5rc3-alt1
- 1.2.5rc3

* Tue May 14 2002 Konstantin Timoshenko <kt@altlinux.ru> 1.2.5rc2-alt1
- 1.2.5rc2
- Re-enable sendfile.

* Mon May 13 2002 Konstantin Timoshenko <kt@altlinux.ru> 1.2.5rc1-alt2
- apply patch from CVS to fix bug with users being unable to overwrite files
  they have permission to (patch #7)
- remove --enable-sendfile from configure

* Thu Dec 20 2001 Konstantin Timoshenko <kt@altlinux.ru> 1.2.5rc1-alt1
- 1.2.5rc1.
- mod_wrap 1.2.3.
- fix pam configuration.

* Wed Dec 19 2001 Dmitry V. Levin <ldv@alt-linux.org> 1.2.4-alt2
- Fixed glob problem.
- Updated pam configuration (needs checking).

* Mon Oct 22 2001 Konstantin Timoshenko <kt@altlinux.ru> 1.2.4-alt1
- 1.2.4

* Fri Oct 19 2001 Konstantin Timoshenko <kt@altlinux.ru> 1.2.3-alt1
- 1.2.3

* Wed Oct  3 2001 Kostya Timoshenko <kt@altlinux.ru> 1.2.2-alt3
- Enable AllowStoreRestart so FTP resume works.

* Fri Aug 31 2001 Dmitry V. Levin <ldv@altlinux.ru> 1.2.2-alt2
- Added "rlimit_as = 16M" to xinetd config.
- Fixed %%post/%%preun scripts.

* Tue Aug 21 2001 Kostya Timoshenko <kt@altlinux.ru> 1.2.2-alt1
- 1.2.2.
- added LDAP support v2.7.6
- added LDAP configuration directives to proftpd.conf
- patched makefile to compile mod_ldap

* Tue Apr 24 2001 Kostya Timoshenko <kt@altlinux.ru> 1.2.2rc2-alt1
- 1.2.2rc2

* Sun Mar 25 2001 Kostya Timoshenko <kt@petr.kz> 1.2.2rc1-ipl1mdk
- 1.2.2rc1
- fix configs to use nobody.nobody not nobody.nogroup to run as nogroup
  seems to no longer exist

* Fri Mar 16 2001 Kostya Timoshenko <kt@petr.kz> 1.2.1-ipl3mdk
- fix workaround for ls bug

* Sun Mar 11 2001 Kostya Timoshenko <kt@petr.kz> 1.2.1-ipl2mdk
- Don't enable Anonymous login by default.
- URL change from .net -> .org
- remove chkconfig entry

* Mon Mar  5 2001 Kostya Timoshenko <kt@petr.kz> 1.2.1-ipl1mdk
- 1.2.1
- fix xinetd config

* Wed Feb 28 2001 Kostya Timoshenko <kt@petr.kz> 1.2.0-ipl1mdk
- 1.2.0 final version

* Mon Feb 12 2001 Kostya Timoshenko <kt@petr.kz> 1.2.0rc3-ipl1mdk
- 1.2.0rc3: security update

* Wed Jan 24 2001 Kostya Timoshenko <kt@petr.kz>
- fix PASV mode bug

* Tue Jan 23 2001 Kostya Timoshenko <kt@petr.kz>
- fix proftpd.init
- rebuild for RE

* Wed Nov 01 2000 Geoffrey Lee <snailtalk@mandrakesoft.com> 1.2.0rc2-9mdk
- fix the anonymous login in proftpd configuration files.

* Wed Sep 27 2000 Geoffrey Lee <snailtalk@mandrakesoft.com> 1.2.0rc2-7mdk
- really fix inetd problem. We remnove it from /etc/inetd.conf, and let it
  run instandalone mode which seems to work quite fine ...

* Fri Sep 22 2000 Geoffrey Lee <snailtalk@mandrakesoft.com> 1.2.0rc2-6mdk
- really add the xinetd entry.

* Thu Sep 21 2000 Geoffrey Lee <snailtalk@mandrakesoft.com> 1.2.0rc2-5mdk
- include the chkconfig entry, but don't run chkconfig by default.
- add an xinetd entry.
- re-add the inetd.conf entry ...

* Fri Sep 15 2000 Geoffrey Lee <snailtalk@mandrakesoft.com> 1.2.0rc2-4mdk
- rebuild for the Big Move (tm) and hope that I don't break anything.
- remove inetd.conf entry (again, hoping that I don't break anything.)

* Tue Aug 29 2000 Geoffrey Lee <snailtalk@mandrakesoft.com> 1.2.0rc2-3mdk
- use of _initrddir.

* Wed Aug 23 2000 Geoffrey Lee <snailtalk@mandrakesoft.com> 1.2.0rc2-2mdk
- quick and ugly hack to fix wu-ftpd breakage when proftpd is uninstalled.
- change the description as the AUTH patch is no longer here.

* Sat Jul 29 2000 Geoffrey Lee <snailtalk@mandrakesoft.com> 1.2.0rc2-1mdk
- new version
- remove the packager tag (vincentscks)

* Wed Jul 19 2000 Vincent Danen <vdanen@mandrakesoft.com> 1.2.0rc1-3mdk
- rebuild for directory changes

* Tue Jul 18 2000 Vincent Danen <vdanen@mandrakesoft.com> 1.2.0rc1-2mdk
- add directory /var/log/proftpd
- add home directory /home/ftp
- add conflicts with anonftp
- fix so can install as nonroot
- add --enable-autoshadow to configure

* Wed Jul 12 2000 Vincent Danen <vdanen@mandrakesoft.com> 1.2.0rc1-1mdk
- 1.2.0rc1
- macroization
- remove directory /home/ftp since we don't need it

* Fri Jun 30 2000 Vincent Danen <vdanen@linux-mandrake.com> 1.2.0pre10-2mdk
- merge with .spec file from Geoffrey Lee <snailtalk@linux-mandrake.com>:
- add logrotate entry
- add symlinks to in.proftpd and in.ftpd
- on uninstall, run /etc/rc.d/init.d/proftpd stop prior to uninstall
- compile with mod_pam support
- add Conflicts: wu-ftpd, ncftpd, beroftpd

* Fri May  5 2000 Vincent Danen <vdanen@linux-mandrake.com> 1.2.0pre10-1mdk
- build for Mandrake
- bzip sources
- bzip manpages
- remove multi-package creation.  one package does all... updates
  /etc/inetd.conf but defaults to standalone server type

* Thu Oct 3 1999 O.Elliyasa <osman@Cable.EU.org>
- Multi package creation.
  Created core, standalone, inetd (&doc) package creations.
  Added startup script for init.d
  Need to make the "standalone & inetd" packages being created as "noarch"
- Added URL.
- Added prefix to make the package relocatable.

* Wed Sep 8 1999 O.Elliyasa <osman@Cable.EU.org>
- Corrected inetd.conf line addition/change logic.

* Sat Jul 24 1999 MacGyver <macgyver@tos.net>
- Initial import of spec.
